#include <wx/wx.h>
#include <wx/timer.h>

#include <time.h>

#include "define.h"
#include "port.h"

int xinit=190,yinit=4,xancho=490,yancho=530,lugar=-10;
int zx,zy;
long numero;

int tiempo2=10,tiempo1=5,tiempo0,tiempo=0,tiempox=0;
unsigned int tiempoEtomas=0,tiempoUtoma;
int humedad=1000,temperatura=-3000,numcanal,contador;
int marcas=10, marcas1=11;


int  ContadorI=0;
char Binput[100];
char Binput2[10];
char VARI[100];

time_t hora;
struct tm *phora;

FILE *fp;

// Declare the application class
class MiAplicacion : public wxApp
{
public:
    // Called on application startup
    virtual bool OnInit();
};


// Declare our main frame class
class MiFrame : public wxFrame
{
public:
    // Constructor
    MiFrame(const wxString& title);
    // Event handlers

    void MiTimer(wxTimerEvent& event);
    void Boton1(wxCommandEvent& event);
    void Boton2(wxCommandEvent& event);
    void OnQuit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnPaint(wxPaintEvent& event);
    void OnComboBox1Select(wxCommandEvent& event);


private:
    // This class handles events
    DECLARE_EVENT_TABLE()

    wxStaticText* StaticText9;
    wxTextCtrl* TextCtrl4;
    wxStaticText* StaticText2;
    wxButton* Button1;
    wxStaticText* StaticText6;
    wxTextCtrl* TextCtrl6;
    wxStaticText* StaticText8;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxButton* Button2;
    wxStaticText* StaticText5;
    wxStaticText* StaticText7;
    wxStatusBar* StatusBar1;
    wxTextCtrl* TextCtrl2;
    wxTextCtrl* TextCtrl1;
    wxTextCtrl* TextCtrl5;
    wxStaticText* StaticText4;
    wxTextCtrl* TextCtrl3;

    wxStaticText* Tgrados;
    wxStaticText* Tciento;

    wxComboBox* ComboBox1;
    wxCheckBox* CheckBox1;

    wxSingleChoiceDialog* SingleChoiceDialog1;

    wxBitmap *m_bitmap;
    wxPaintDC dc0;
    wxMemoryDC dc;

};


// Implements MiAplicacion& GetApp()
DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

// Event table for MiFrame
BEGIN_EVENT_TABLE(MiFrame, wxFrame)
    EVT_MENU(wxID_ABOUT, MiFrame::OnAbout)
    EVT_MENU(wxID_EXIT, MiFrame::OnQuit)
    EVT_BUTTON(1001, MiFrame::Boton1)
    EVT_BUTTON(1002, MiFrame::Boton2)
    EVT_TIMER(1000, MiFrame::MiTimer)
    EVT_COMBOBOX(1003,MiFrame::OnComboBox1Select)
    EVT_PAINT(MiFrame::OnPaint)
END_EVENT_TABLE();

// Initialize the application
bool MiAplicacion::OnInit()
{
    printf("Creando MiAplicacion\n");
    MiFrame  *frame =  new MiFrame(wxT("Monitor temperatura humedad"));
    frame->Show(true);
    return true;
}


void MiFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg;
    msg.Printf(wxT("Monitor Temperatura / Humedad \nxsetaseta@gmail.com\n%s"),	wxVERSION_STRING);
    wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
}

void MiFrame::OnQuit(wxCommandEvent& event)
{
	fclose(fp);
    CloseRs232();
    Close();
}

//Boton Salir
void MiFrame::Boton1(wxCommandEvent& event)
{
    fclose(fp);
    CloseRs232();
    Close();
}

//Boton limpiar grafica
void MiFrame::Boton2(wxCommandEvent& event)
{
    lugar=-4;
}

void MiFrame::OnComboBox1Select(wxCommandEvent& event)
{
    wxString msg;
    msg=ComboBox1->GetStringSelection();
    marcas=wxAtoi(msg);
    if(DEBUG)printf("Marcas=%d\n",marcas);
}

void MiFrame::OnPaint(wxPaintEvent& event)
{

 	//wxClientDC dc0(this );
	wxPaintDC dc0(this);
	wxMemoryDC dc(*m_bitmap);
	dc0.Blit(xinit,yinit,xancho,yancho, &dc, 0, 0, wxCOPY, true);
//	printf("d-repintar Onpaint Tem=%d Hum=%d  \n",temperatura,humedad);
	
}


void MiFrame::MiTimer(wxTimerEvent& event)
{
	float dd,dd1;
	int z,zz,z1;
	
	int nbytes;
	wxString msg;

	wxMemoryDC dc(*m_bitmap);
	wxClientDC dc0(this );
	//wxPaintDC dc0(this);

	tiempo0--;
	tiempo1--;
	tiempo2--;	

// cada 0,5 segundos
if(tiempo2<0)
		{
			tiempo2=10;	
						
#if YesWindows
                    while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		            while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
				{
					// printf("Leer %d -> %s\n",ContadorI,Binput2);	
					Binput[ContadorI]=Binput2[0];
					ContadorI++;
					if (Binput2[0] == '\n')
						{
							if(ContadorI<2)ContadorI=2;   
							Binput[ContadorI-2]=0;
							ContadorI=0;	
							if(DEBUG)printf("Leidos-> %s\n",Binput);
							//printf("MMLeidos-> %s\n",Binput);
							//sprintf(VARI,"%s",Binput);													
							//printf("%s\n",VARI);
							msg=wxString::FromAscii(Binput);							
							TextCtrl2->SetValue(msg);
							zz=0;
							for(z=1;z<20;z++,zz++)
								{
								 if((VARI[zz]=Binput[z])==32)
										{
										 VARI[zz]=0;
										 break;	
										}						
								}
							humedad=atoi(VARI);
							zz=0;	z+=2;
							for(;z<20;z++,zz++)
								{								 
								 if((VARI[zz]=Binput[z])==32)
										{
										 VARI[zz]=0;
										 break;	
										}						
								}
							temperatura=atoi(VARI);
							zz=0;	z++;
							for(;z<20;z++,zz++)
								{								 
								 if((VARI[zz]=Binput[z])==32)
										{
										 VARI[zz]=0;
										 break;	
										}						
								}
							numcanal=atoi(VARI);
							zz=0;	z++;
							for(;z<20;z++,zz++)
								{								 
								 if((VARI[zz]=Binput[z])==32)	
										{
										 VARI[zz]=0;
										 break;	
										}						
								}
							contador=atoi(VARI);
							if(DEBUG)printf("DATO1=%d DATO2=%d DATO3=%d DATO4=%d\n",humedad,temperatura,numcanal,contador);
							
							dd=temperatura;  dd/=100;
							msg.Printf(wxT("%0.2f"),dd);    
							TextCtrl3->SetValue(msg);
							
							dd=humedad;  dd/=100;
							msg.Printf(wxT("%0.2f"),dd);  
							TextCtrl4->SetValue(msg);
							
							msg.Printf(wxT("%d"),tiempoEtomas);    
							TextCtrl5->SetValue(msg);
							tiempoEtomas=0;
							tiempoUtoma=0;
							if(CheckBox1->GetValue()) lugar+=2;
							
							hora= time( NULL );
							phora = gmtime( &hora );
							
							sprintf(VARI,"%dM%dD%dH%dM%dS\n",(phora->tm_mon+1),phora->tm_mday,phora->tm_hour,phora->tm_min, phora->tm_sec );	   						
							fprintf(fp, "%d,%d,%d,%s",tiempo,temperatura,humedad,VARI);
						} 
				}
				
		}	 

// cada 1 segundos ____________________________________________
	if(tiempo1<0)
		{
			tiempo1=20;

			tiempoEtomas++;
			tiempoUtoma++;
			tiempo++;	
			marcas1++;
			//printf("%d   %d\n",marcas1,marcas );
			if(marcas1>marcas)		
				{
				 marcas1=0;
				 wxPen penBlanco(*wxWHITE, 1);
				 dc.SetPen(penBlanco);
				 dc.DrawLine(lugar-1,yancho-10,lugar-1,yancho);
				 dc0.Blit(xinit,yinit,xancho,yancho, &dc, 0, 0, wxCOPY, true);
				}
		 	msg.Printf(wxT("%d"),tiempo);    
		 	TextCtrl1->SetValue(msg);	

			msg.Printf(wxT("%d"),tiempoUtoma);    
			TextCtrl6->SetValue(msg);
		}
	if(tiempo0<0)
		{
		 tiempo0=20;	
//		 lugar +=2;							

		 if(!CheckBox1->GetValue()) lugar+=2;
		
		 wxPen penR(*wxRED, 1);
		 wxPen penB(*wxBLUE, 1); 
		 wxPen penBlanco(*wxWHITE, 1);
		 if (lugar>xancho-2 || lugar<0)
			{
		  
		 	 lugar=47; 
		  	 wxColor Negro(0,0,0);
		 	 wxPen myNegroPen(Negro,1,wxSOLID);
		 	 dc.SetBrush(*wxWHITE_BRUSH);		  
		 	 dc.SetPen(myNegroPen);
		 	 dc.DrawRectangle(0,0,xancho,yancho);


				dc.SetPen(penR);
				dd=yancho;
				dd/=12;
				dd1=yancho;
				z1=-40;			
				for(zz=0;zz<13;zz++)
					{	
					 z=dd1;
//					 printf("%d\n",z );
					 msg.Printf(wxT("%d"),z1);
					 dc.DrawText(msg,2,z);
					 dc.DrawLine(2 ,z,15,z);
					 z1+=10;
					 dd1-=dd;
					}	

				dc.SetPen(penB);
				dd=yancho;
				dd/=10;
				dd1=yancho;
				z1=0;
				for(zz=0;zz<11;zz++)
					{					 	
					 z=dd1;
					 dc.DrawLine(27 ,z,40,z);
					 msg.Printf(wxT("%d"),z1);
					 dc.DrawText(msg,27,z);
					 z1+=10;					 
					 dd1-=dd;
					}		  
			}	
			else
			{
        	 dc.SetPen(penBlanco);
			 dc.DrawLine(2,0,2,yancho);
			 dc.DrawLine(27,0,27,yancho);

      	  	 z=temperatura+4000;
      	   	 numero=yancho*z;
       	 	 numero/=12000;
       	  	 numero++;
       	 	 zy=yancho-numero;

       	 	 dc.SetPen(penR);
        	 dc.DrawLine(lugar,zy,lugar,yancho);
        	 dc.DrawLine(2,zy,2,yancho);
           
        	 z=humedad;
        	 numero=yancho*z;
        	 numero/=10000;
        	 numero++;
        	 zy=yancho-numero;

        	 dc.SetPen(penB);
        	 dc.DrawLine(lugar+1,yancho,lugar+1,zy); 
        	 dc.DrawLine(27,yancho,27,zy);    	
			}
	
	       dc0.Blit(xinit,yinit,xancho,yancho, &dc, 0, 0, wxCOPY, true);
		
        }
}



MiFrame::MiFrame(const wxString& title) : wxFrame(NULL, wxID_ANY, title)
{

    wxString msg;

    printf("Creando MiFrame\n");
    SetClientSize(wxSize(700,600));
    SetMinSize(wxSize(700,600));
    SetMaxSize(wxSize(700,600));

    wxMenu *fileMenu = new wxMenu;

    wxMenu *helpMenu = new wxMenu;
    helpMenu->Append(wxID_ABOUT, wxT("&Acerca...\tF1"), wxT("Acerca"));
    fileMenu->Append(wxID_EXIT, wxT("E&xit\tAlt-X"), wxT("Salir"));

    wxMenuBar *menuBar = new wxMenuBar();
    menuBar->Append(fileMenu, wxT("&Menu"));
    menuBar->Append(helpMenu, wxT("&Help"));
    SetMenuBar(menuBar);

    CreateStatusBar(2);
    SetStatusText(wxT("Monitor temperatura/humedad"));

    wxFont TextFont12(12,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);

    TextCtrl1 = new wxTextCtrl(this, wxID_ANY, _("-"), wxPoint(8,32), wxSize(80,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    TextCtrl1->Disable();
    TextCtrl2 = new wxTextCtrl(this, wxID_ANY, _("-"), wxPoint(8,64), wxSize(160,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    StaticText1 = new wxStaticText(this, wxID_ANY, _("Segundos transcurridos"), wxPoint(16,16), wxSize(152,16), 0, _T("ID_STATICTEXT1"));
    StaticText2 = new wxStaticText(this, wxID_ANY, _("Temperatura"), wxPoint(8,104), wxDefaultSize, 0, _T("ID_STATICTEXT2"));
    StaticText3 = new wxStaticText(this, wxID_ANY, _("Humedad"), wxPoint(8,136), wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    TextCtrl3 = new wxTextCtrl(this, wxID_ANY, _("-"), wxPoint(94,96), wxSize(56,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    TextCtrl4 = new wxTextCtrl(this, wxID_ANY, _("-"), wxPoint(94,128), wxSize(56,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
    TextCtrl3->SetFont(TextFont12);
    TextCtrl4->SetFont(TextFont12);

    StaticText4 = new wxStaticText(this, wxID_ANY, _("xsetaseta@gmail.com"), wxPoint(8,408), wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    StaticText5 = new wxStaticText(this, wxID_ANY, _("http://www.seta43.netau.net"), wxPoint(8,424), wxDefaultSize, 0, _T("ID_STATICTEXT5"));
    StaticText5->SetMinSize(wxSize(0,0));
    wxFont StaticText5Font(7,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText5->SetFont(StaticText5Font);

    StaticText6 = new wxStaticText(this, wxID_ANY, _("Tiempo entre tomas"), wxPoint(8,188), wxDefaultSize, 0, _T("ID_STATICTEXT6"));
    StaticText7 = new wxStaticText(this, wxID_ANY, _("Tiempo desde última toma"), wxPoint(8,232), wxSize(136,11), 0, _T("ID_STATICTEXT7"));
    Button1 = new wxButton(this, 1002, _("Limpiar gráfica"), wxPoint(8,312), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    Button2 = new wxButton(this, 1001, _("Exit"), wxPoint(8,440), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    TextCtrl5 = new wxTextCtrl(this, wxID_ANY, _("0"), wxPoint(12,204), wxSize(56,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
    TextCtrl6 = new wxTextCtrl(this, wxID_ANY, _("-"), wxPoint(12,248), wxSize(56,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
    StaticText8 = new wxStaticText(this, wxID_ANY, _("S"), wxPoint(76,209), wxDefaultSize, 0, _T("ID_STATICTEXT8"));
    StaticText9 = new wxStaticText(this, wxID_ANY, _("S"), wxPoint(76,256), wxDefaultSize, 0, _T("ID_STATICTEXT9"));

    Tgrados = new wxStaticText(this, wxID_ANY, _("ºC"), wxPoint(150,102), wxDefaultSize, 0, _T("ID_STATICTEXT8"));
    Tciento = new wxStaticText(this, wxID_ANY, _("%"), wxPoint(150,134), wxDefaultSize, 0, _T("ID_STATICTEXT9"));

    ComboBox1 = new wxComboBox(this, 1003, wxEmptyString, wxPoint(8,368), wxSize(152,27), 0, 0, 0, wxDefaultValidator, _T("ID_COMBOBOX1"));
    ComboBox1->SetSelection( ComboBox1->Append(_("10")) );
    ComboBox1->Append(_("15"));
    ComboBox1->Append(_("30"));
    ComboBox1->Append(_("60"));
    ComboBox1->Append(_("120"));
    ComboBox1->Append(_("300"));
    ComboBox1->Append(_("600"));
    ComboBox1->Append(_("1800"));
    ComboBox1->Append(_("3600"));

    CheckBox1 = new wxCheckBox(this, wxID_ANY, _("Modo señal"), wxPoint(8,280), wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
    CheckBox1->SetValue(true);
#if YesWindows	
	wxString __wxSingleChoiceDialogChoices_1[8] =
     {
    	_("com1"),_("com2"),_("com3"),_("com4"),_("com5"),_("com6"),_("com7"),_("com8")
     };
#else
    wxString __wxSingleChoiceDialogChoices_1[8] =
    {
        _("/dev/ttyUSB0"), _("/dev/ttyUSB1"),  _("/dev/ttyUSB2"), _("/dev/ttyACM0"), _("/dev/ttyACM1"), _("/dev/ttyACM2"), _("/dev/ttyS0"), _("/dev/ttyS1")
    };
#endif	
	
    SingleChoiceDialog1 = new wxSingleChoiceDialog(this, _("Selecciona puerto"), wxEmptyString, 8, __wxSingleChoiceDialogChoices_1, 0, wxCHOICEDLG_STYLE, wxDefaultPosition);
    SingleChoiceDialog1->ShowModal();
	msg=SingleChoiceDialog1->GetStringSelection();
		
    strcpy( VARI, (const char*)msg.mb_str(wxConvUTF8) );
    MODEMDEVICE=VARI;

    if(0!=IniRs232())
    {
        printf("NO %s\n",MODEMDEVICE);
        msg.Printf(wxT("No existe puerto"));
        wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
        Close();
    }
    else
    {
		if(DEBUG) printf("SI %s\n",MODEMDEVICE);    		
        SetStatusText(msg);
    }


    hora= time( NULL ); 
    if(DEBUG)printf( "HORA: %li Segundo\n", hora );
    phora = gmtime( &hora );
//	   printf( "Hora1: %s\n", asctime(phora) );
//	   printf( "Hora2:%d/%d/%d_%d_%d\n",(phora->tm_mon+1),phora->tm_mday,phora->tm_hour,phora->tm_min, phora->tm_sec );
    sprintf(VARI,"%dM%dD%dH%dM%dS.csv",(phora->tm_mon+1),phora->tm_mday,phora->tm_hour,phora->tm_min, phora->tm_sec );
    if(DEBUG)printf("Fichero %s\n",VARI);

    if(!(fp=fopen(VARI,"w")))
    {
        wxString string(VARI, wxConvUTF8);
        wxMessageBox(string, wxT("Error creando"));
        Close();
    }
    else
    {
        printf("Creado fichero %s\n",VARI );
        fprintf(fp, "Segundos, Temperatura, Humedad\n");
    }

    msg=wxString::FromUTF8(VARI);
    SetStatusText(msg ,1);

    m_bitmap = new wxBitmap(xancho, yancho, 32);

    wxColor Negro(0,0,0);
    wxPen penBlanco(*wxWHITE, 1);
    wxPen penR(*wxRED, 1);
    wxPen penB(*wxBLUE, 1);
    wxPen myNegroPen(Negro,1,wxSOLID);

    wxTimer *MiTimer= new wxTimer();
    MiTimer->SetOwner(this, 1000);
    MiTimer->Start(50);	// 20 veces por Segundo
	
    
}





